# Parsec Cloud (https://parsec.cloud) Copyright (c) AGPL-3.0 2016-present Scille SAS

from __future__ import annotations

from parsec._parsec_pyi.crypto import PublicKey, VerifyKey
from parsec._parsec_pyi.enumerate import UserProfile
from parsec._parsec_pyi.ids import DeviceID, DeviceLabel, HumanHandle

class PkiEnrollmentAnswerPayload:
    def __init__(
        self,
        device_id: DeviceID,
        device_label: DeviceLabel | None,
        human_handle: HumanHandle | None,
        profile: UserProfile,
        root_verify_key: VerifyKey,
    ): ...
    @property
    def device_id(self) -> DeviceID: ...
    @property
    def device_label(self) -> DeviceLabel | None: ...
    @property
    def human_handle(self) -> HumanHandle | None: ...
    @property
    def profile(self) -> UserProfile: ...
    @property
    def root_verify_key(self) -> VerifyKey: ...
    @classmethod
    def load(cls, raw: bytes) -> PkiEnrollmentAnswerPayload: ...
    def dump(self) -> bytes: ...

class PkiEnrollmentSubmitPayload:
    def __init__(
        self, verify_key: VerifyKey, public_key: PublicKey, requested_device_label: DeviceLabel
    ) -> None: ...
    @property
    def verify_key(self) -> VerifyKey: ...
    @property
    def public_key(self) -> PublicKey: ...
    @property
    def requested_device_label(self) -> DeviceLabel: ...
    @classmethod
    def load(cls, raw: bytes) -> PkiEnrollmentSubmitPayload: ...
    def dump(self) -> bytes: ...
